###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import calendar_month
import base_item
import time
import calendar
import utils

calendar_year_add_redirect = HTMLFile('calendar_year_add_redirect', globals())
manage_add_calendar_year_form = HTMLFile('calendar_year_add', globals())


def manage_add_calendar_year(self, id, title, REQUEST=None, RESPONSE=None):
    "Add an instance of the calendar_year class"

    self._setObject(id, calendar_year(id, title))

    if RESPONSE is not None:

        RESPONSE.redirect(self.absolute_url())


class calendar_year(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'CalendarYear'
	icon = 'misc_/Transform/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		)

	meta_types = (
		{'name':'CalendarMonth', 'action':'manage_add_calendar_month_form'},
		)

	manage_add_calendar_month_form = calendar_month.manage_add_calendar_month_form
	manage_add_calendar_month = calendar_month.manage_add_calendar_month
	calendar_month_add_redirect = calendar_month.calendar_month_add_redirect

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add CalendarMonth',
		 ('manage_add_calendar_month', 'manage_add_calendar_month_form')),
		('View CalendarYears',
		 ('',)),
		)

	index_html = HTMLFile('calendar_year_index', globals())

	def __init__(self, id, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title

		for month in range(1,13):

			self.manage_add_calendar_month(utils.pad_integer(month),
										   title=calendar.month_name[month])

			for week in calendar.monthcalendar(int(self.id), month):

				for day in range(len(week)):

					if week[day]:

						self[utils.pad_integer(month)].manage_add_calendar_day(
							utils.pad_integer(week[day]),
							title=calendar.day_name[day])


default__class_init__(calendar_year)

